<?php
class ModelExtensionModuleSmsIppanel extends Model {
	const PATTERN_PHONE	= '/^(\+)?(country_code)?0?\d+$/';
	/* دریافت تمام قالب های پیامکی از دیتابیس */
	private function getTemplates($type, $store_id) { 
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "smsippanel_template AS st LEFT JOIN " . DB_PREFIX . "smsippanel_template_message AS stm ON st.sms_template_id = stm.sms_template_id LEFT JOIN " . DB_PREFIX . "language  AS lg ON lg.language_id = stm.language_id WHERE st.type = '" . $this->db->escape($type) . "' AND st.store_id = '" . (int)$store_id . "' AND lg.`code` = '" . $this->config->get('config_language') . "'");
		return $query->rows;
	}
	/* جستجوی متغیرها در متن پیامک ها */
	private function getSearch($type) {
		if ($type == 'register') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{password}'
			);
		} elseif ($type == 'affiliate') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{password}'
			);
		} elseif ($type == 'affiliate_transaction') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{commission}',
				'{total_commission}'
			);
		} elseif ($type == 'affiliate_approve') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}'
			);
		} elseif ($type == 'forgotten') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{password}'
			);
		} elseif ($type == 'order') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{order_id}',
				'{date_added}',
				'{payment_method}',
				'{shipping_method}',
				'{ip}',
				'{order_comment}',
				'{payment_address}',
				'{shipping_address}',
				'{products}'
			);
		} elseif ($type == 'reward') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{points}',
				'{total_points}'
			);
		} elseif ($type == 'account_approve') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}'
			);
		} elseif ($type == 'account_transaction') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{credits}',
				'{total_credits}'
			);
		} else {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{order_id}',
				'{date_added}',
				'{payment_method}',
				'{shipping_method}',
				'{ip}',
				'{order_comment}',
				'{payment_address}',
				'{shipping_address}',
				'{products}'
			);
		}
	
		return $search;
	}
	/* جایگذاری مقدار متغیرها و ارسال پیامک */
	public function parseSMS($type, $store_id, $number, $replace) {
	
		$number = preg_replace('/[^0-9]/', '', $number);
		

		$templates = $this->getTemplates($type, $store_id);
	
		
		$template_data = false;
		foreach ($templates as $template) {
			$template_data = $template;
		}
	    
		if ($template_data && !empty($template_data['message'])) {
			$search = $this->getSearch($type);
			
			$message = strip_tags(str_replace($search, $replace, html_entity_decode($template_data['message'])));
			
			$this->sendSMS($number, $message);
			if($template_data['bcc'] && !empty($template_data['adminmessage'])){
				$numbers = explode(',', $template_data['bcc']);
				$adminmessage = strip_tags(str_replace($search, $replace, html_entity_decode($template_data['adminmessage'])));
				foreach ($numbers as $number) {
					$this->sendSMS($number, $adminmessage);
				}
			}
		} else {
			return false;
		}
	}
	/* دستور ارسال پیامک به وب سرویس */
	public function sendSMS($receiver = null, $message = null) {
		$response = false;
		$username = trim($this->config->get('smsippanel_username'));
		$password = trim($this->config->get('smsippanel_password'));
		$from     = trim($this->config->get('smsippanel_default_from'));
		$debug    = $this->config->get('smsippanel_debug');
		$massage  = str_replace(array('https://','http://','www.'), array('','',''), $message);
		if($debug == 1){
			$result = "SMS DEBUG(catalog): Reciver: {$receiver} - message : {$massage}";
			error_log($result);
			$this->log->write($result);
			$this->session->data['success'] = $result;
			return 'debug';
		}
		if ( empty( $username ) || empty( $password ) || empty( $from ) ||  empty( $receiver ) ||  empty( $massage ) ) {
			return $response;
		}

		if(is_array($receiver)) $to = $receiver; else $to = explode(',',$receiver);
		$massage = str_replace('patterncode:','pcode:',strip_tags(trim($massage)));
		if (substr( $massage, 0, 5 ) === "pcode"){
			if($debug == 1) $this->log->write($massage);
			$massage = str_replace("\r\n",';',$massage);
			$massage = str_replace("\n",';',$massage);
			$splited = explode(';', $massage);
			$patterncodeArray = explode(':', $splited[0]);
			$patterncode = trim($patterncodeArray[1]);
			unset($splited[0]);
			$input_data = array();
			foreach($splited as $parm){
			  $splited_parm = explode(':', $parm);
			  $input_data[trim($splited_parm[0])] = trim($splited_parm[1]);
			}
			if($debug == 1) $this->log->write(json_encode($input_data));
			$url = "/patterns/pattern?username=".$username."&password=".urlencode($password)."&from=$from&to=".json_encode($to)."&input_data=".urlencode(json_encode($input_data))."&pattern_code=".$patterncode;
			if($debug == 1) $this->log->write($url);
			$result = $this->cUrl( $url, array(), 'GET' );

			if ( ! empty( $result ) && is_numeric( $result ) ) {
				$response = true;
			} else {
				$this->log->write($this->getErrors($res_code));
				$this->session->data['warning'] = $this->getErrors($res_code);
			    error_log($res_code . ':' .$this->getErrors($res_code));
				$response = $res_code . ':' .$this->getErrors($res_code);
			}

			return $response;
		}else{
			$url = "/services.jspd";
			$params = array
						(
							'uname'=>$username,
							'pass'=>$password,
							'from'=>$from,
							'message'=>$massage,
							'to'=>json_encode($to),
							'op'=>'send'
						);

			$result = $this->cUrl( $url, $params, 'POST' );
			$result2 = json_decode($result);
			$res_code = $result2[0];
			$res_data = $result2[1];
			if ($res_code == '0'){
				$response = true;
			} else {
				$this->log->write($this->getErrors($res_code));
				$this->session->data['warning'] = $this->getErrors($res_code);
			    error_log($res_code . ':' .$this->getErrors($res_code));
				$response = $res_code . ':' .$this->getErrors($res_code);
			}
			return $response;
		}
	}
	
	public function sendOtp($receiver,$template=NULL) {
		$error='';$response_arr=array();
		$rand = rand('1111','99999');
		$this->session->data['ippanel_otp'] = $rand;
		$template = strip_tags(str_replace(array('[url]','[otp]'), array(HTTPS_SERVER,$rand), html_entity_decode($template)));

		$country_code=$this->config->get('smsalert_country');
		$no = preg_replace('/[^0-9]/', '', $receiver);
		$no = ltrim($no, '0');
		$no = trim($no, ' ');
		$match = preg_match($this->getPhonePattern(),$no);
		/*closed added on 06-05-2019 */
		if($match)
		{
			$no = (substr($no,0,strlen($country_code))!=$country_code) ? $country_code.$no : $no;
			$cookie_value = $this->get_ippanel_cookie($no);
		    $max_otp_resend_allowed = $this->config->get('smsalert_resend_allowed')!=''?$this->config->get('smsalert_resend_allowed'):'4';
			if($this->get_ippanel_cookie($no)>$max_otp_resend_allowed)
			{
				$data=array();
				$data['error']= 'You have reached to max allowed resend, please try after 15 minutes';
				return $data;
			}
			$response = $this->sendSMS($no,$template);
			if($response == true){
				$response_arr['status'] = 'success';
			}
			if($response_arr['status']=='error') {
				$error = $response;
		   }
		   else{
			   $this->create_ippanel_cookie($no,$cookie_value+1);
		   }
		}
		else{
			$error = 'invalid numbers';
		}
		 $response_arr['error']=$error;
		return $response_arr;
	}
	

	public function verifyOtp($receiver,$code) {
		$error='';$response_arr=array();
		if (!isset($this->session->data['ippanel_otp'])) {
			return;
		}
		
		/*added on 06-05-2019 */
		$country_code=$this->config->get('smsalert_country');
	    $no = preg_replace('/[^0-9]/', '', $receiver);
		$no = ltrim($no, '0');
		$no = trim($no, ' ');
		$no = (substr($no,0,strlen($country_code))!=$country_code) ? $country_code.$no : $no;
		$match = preg_match($this->getPhonePattern(),$no);
		/*closed added on 06-05-2019 */
		$response_arr['status'] = 'false';
		
		if($match)
		{
			if($this->session->data['ippanel_otp'] == $code){
				$this->clear_ippanel_cookie($no);
				$response_arr['status'] = 'success';
				$response_arr['description']['desc'] = 'Code Matched successfully.';
			} else {
				$response_arr['description']['desc'] = 'Code invalid!';
			}
		} else {
			$response_arr['description']['desc'] = 'Code invalid!';
		}
		return $response_arr;
	}
	/* دستور ارتباط با وب سرویس */
	private function cUrl( $url, $params = array() , $method = 'POST' ) {
		$domain     = trim($this->config->get('smsippanel_domain'));
		if(empty($domain)) $domain = "https://ippanel.com";
		$handler = curl_init($domain.$url);        
		curl_setopt($handler, CURLOPT_CONNECTTIMEOUT, 5); 
		curl_setopt($handler, CURLOPT_TIMEOUT, 20);
		curl_setopt($handler, CURLOPT_CUSTOMREQUEST, $method);
		if($method == 'POST') curl_setopt($handler, CURLOPT_POSTFIELDS, $params);
		curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
		$result = curl_exec($handler); 
		return $result;
	}
	/* لیست خطاهای وب سرویس*/
	private function getErrors($error){
		$errorCodes = array(
			'0'  => 'عملیات با موفقیت انجام شده است.',
			'1'  => 'متن پیام خالی می باشد.',
			'2'  => 'کاربر محدود گردیده است.',
			'3'  => 'خط به شما تعلق ندارد.',
			'4'  => 'گیرندگان خالی است.',
			'5'  => 'اعتبار کافی نیست.',
			'7'  => 'خط مورد نظر برای ارسال انبوه مناسب نمیباشد.',
			'9'  => 'خط مورد نظر در این ساعت امکان ارسال ندارد.',
			'98' => 'حداکثر تعداد گیرنده رعایت نشدهه است.',
			'99' => 'اپراتور خط ارسالی قطع می باشد.',
			'21' => 'پسوند فایل صوتی نامعتبر است.',
			'22' => 'سایز فایل صوتی نامعتبر است.',
			'23' => 'تعداد تالش در پیام صوتی نامعتبر است.',
			'100' => 'شماره مخاطب دفترچه تلفن نامعتبر می باشد.',
			'101' => 'شماره مخاطب در دفترچه تلفن وجود دارد.',
			'102' => 'شماره مخاطب با موفقیت در دفترچه تلفن ذخیره گردید.',
			'111' => 'حداکثر تعداد گیرنده برای ارسال پیام صوتی رعایت نشده است.',
			'131' => 'تعداد تالش در پیام صوتی باید یکبار باشد.',
			'132' => 'آدرس فایل صوتی وارد نگردیده است.',
			'301' => 'از حرف ویژه در نام کاربری استفاده گردیده است.',
			'302' => 'قیمت گذاری انجام نگریدهه است.',
			'303' => 'نام کاربری وارد نگردیده است.',
			'304' => 'نام کاربری قبال انتخاب گردیده است.',
			'305' => 'نام کاربری وارد نگردیده است.',
			'306' => 'کد ملی وارد نگردیده است.',
			'307' => 'کد ملی به خطا وارد شده است.',
			'308' => 'شماره شناسنامه نا معتبر است.',
			'309' => 'شماره شناسنامه وارد نگردیده است.',
			'310' => 'ایمیل کاربر وارد نگردیده است.',
			'311' => 'شماره تلفن وارد نگردیده است.',
			'312' => 'تلفن به درستی وارد نگردیده است.',
			'313' => 'آدرس شما وارد نگردیده است.',
			'314' => 'شماره موبایل را وارد نکرده اید.',
			'315' => 'شماره موبایل به نادرستی وارد گردیده است.',
			'316' => 'سطح دسترسی به نادرستی وارد گردیده است.',
			'317' => 'کلمه عبور وارد نگردیده است.',
			'404' => 'پترن در دسترس نیست.',
			'455' => 'ارسال در آینده برای کد بالک ارسالی لغو شد.',
			'456' => 'کد بالک ارسالی نامعتبر است.',
			'458' => 'کد تیکت نامعتبر است.',
			'964' => 'شما دسترسی نمایندگی ندارید.',
			'962' => 'نام کاربری یا کلمه عبور نادرست می باشد.',
			'963' => 'دسترسی نامعتبر می باشد.',
			'971' => 'پترن ارسالی نامعتبر است.',
			'970' => 'پارامتر های ارسالی برای پترن نامعتبر است.',
			'972' => 'دریافت کننده برای ارسال پترن نامعتبر می باشد.',
			'992' => 'ارسال پیام از ساعت 8 تا 23 می باشد.',
			'993' => 'دفترچه تلفن باید یک آرایه باشد',
			'994' => 'لطفا تصویری از کارت بانکی خود را از منو مدارک ارسال کنید',
			'995' => 'جهت ارسال با خطوط اشتراکی سامانه، لطفا شماره کارت بانکیه خود را به دلیل تکمیل فرایند  احراز هویت از بخش ارسال مدارک ثبت نمایید.',
			'996' => 'پترن فعال نیست.',
			'997' => 'شما اجازه ارسال از این پترن را ندارید.ه',
			'998' => 'کارت ملی یا کارت بانکی شما تایید نشده است.',
			'1001' => 'فرمت نام کاربری درست نمی باشد)حداقله ۵ کاراکتر، فقط حروف و اعداد(.',
			'1002' => 'گذر واژه خیلی ساده می باشد)حداقل ۸ کاراکتر بوده و نام کاربری،',
			'ایمی' => ' و شماره موبایل در آن وجود نداشته باشد(.',
			'1003' => 'مشکل در ثبت، با پشتیبانی تماس بگیرید.',
			'1004' => 'مشکل در ثبت، با پشتیبانی تماس بگیرید.',
			'1005' => 'مشکل در ثبت، با پشتیبانی تماس بگیرید.',
			'1006' => 'تاریخ ارسال پیام برای گذشته می باشد، لطفا تاریخ ارسال پیام را به درستی وارد نمایید.ه',
		);
		return (isset($errorCodes[$error])) ? $errorCodes[$error] : 'اشکال تعریف نشده با کد :' . $error;
	}
	public function getPhonePattern()
	{
		$country_code=$this->config->get('smsalert_country');
		$pattern = ($this->config->get('smsalert_mobile_pattern')!='') ? $this->config->get('smsalert_mobile_pattern'):self::PATTERN_PHONE;
		
		$country_code = str_replace('+', '', $country_code);
		$pattern_phone = str_replace("country_code",$country_code,$pattern);
		return $pattern_phone;
	}
	function create_ippanel_cookie($cookie_key,$cookie_value)
	{
		ob_start();
		setcookie($cookie_key,$cookie_value, time()+(15 * 60));
		ob_get_clean();
	}
		
	function clear_ippanel_cookie($cookie_key)
	{	
		if(isset($_COOKIE[$cookie_key])){
			unset($_COOKIE[$cookie_key]);
			setcookie( $cookie_key, '', time() - ( 15 * 60 ) );
		}
	}

	function get_ippanel_cookie($cookie_key)
	{
		if(!isset($_COOKIE[$cookie_key])) {
		  return false;
		} else {
		  return $_COOKIE[$cookie_key];
		}
	}
} 	
